using System;
using System.IO;
using System.Text;
using System.Drawing;
using System.Reflection;
using System.Diagnostics;
using System.Collections;
using System.Windows.Forms;
using System.ComponentModel;
using System.Runtime.InteropServices;
using Microsoft.Win32;
using ScriptPortal.Vegas;

public class EntryPoint
{
    Vegas myVegas;

    public void FromVegas(Vegas vegas)
    {
        myVegas = vegas;

        FileStream inis = new FileStream("C:\\Users\\Edward Troxel\\Documents\\Scripts\\ByEdward\\EffectsGUID.txt", FileMode.OpenOrCreate);
        StreamWriter iniw = new StreamWriter(inis);

        //	MessageBox.Show("Checking Audio FX");
        iniw.WriteLine("AudioFX");
        foreach (PlugInNode fx in myVegas.AudioFX)
        {
            try
            {
                string s = fx.Name + " - " + fx.ClassID;
                string t = "";

                if (fx.IsAudio && (!(fx.IsContainer)) && (!(fx.IsPackage)))
                {
                    try
                    {
                        int cnt = 0;
                        foreach (EffectPreset mypreset in fx.Presets)
                        {
                            try
                            {
                                t = s + " - ";
                                t += mypreset.Name + " - " + cnt;
                                iniw.WriteLine(t);
                                cnt++;
                            }
                            catch
                            {
                            }
                        }
                    }
                    catch
                    {
                    }
                }
            }
            catch
            {
            }
        }


        //	MessageBox.Show("Checking Video FX");
        iniw.WriteLine("VideoFX");
        foreach (PlugInNode fx in myVegas.VideoFX)
        {
            string s = fx.Name + " - " + fx.ClassID + " UID: " + fx.UniqueID + "  isOFX: " + fx.IsOFX;

            string t = "";
            int cnt2 = 0;
            foreach (EffectPreset mypreset in fx.Presets)
            {
                try
                {
                    t = s + " - ";
                    t += mypreset.Name + " - " + cnt2;
                    iniw.WriteLine(t);
                    cnt2++;
                }
                catch
                {
                }
            }
        }


        //	MessageBox.Show("Checking Generators");
        iniw.WriteLine("Media Generators");
        foreach (PlugInNode fx in myVegas.Generators)
        {
            string s = fx.Name + " - " + fx.ClassID + " UID: " + fx.UniqueID + "  isOFX: " + fx.IsOFX;

            string t = "";
            int cnt2 = 0;
            foreach (EffectPreset mypreset in fx.Presets)
            {
                try
                {
                    t = s + " - ";
                    t += mypreset.Name + " - " + cnt2;
                    iniw.WriteLine(t);
                    cnt2++;
                }
                catch
                {
                }
            }
        }

        //	MessageBox.Show("Checking Transitions");
        iniw.WriteLine("Transitions");
        foreach (PlugInNode fx in myVegas.Transitions)
        {
            string s = fx.Name + " - " + fx.ClassID + " UID: " + fx.UniqueID + "  isOFX: " + fx.IsOFX;

            string t = "";
            int cnt2 = 0;
            foreach (EffectPreset mypreset in fx.Presets)
            {
                try
                {
                    t = s + " - ";
                    t += mypreset.Name + " - " + cnt2;
                    iniw.WriteLine(t);
                    cnt2++;
                }
                catch
                {
                }
            }
        }

        iniw.WriteLine("Renderers");
        foreach (Renderer renderer in myVegas.Renderers)
        {
            string s = renderer.FileExtension + " - " + renderer.FileTypeName + " - " + renderer.ClassID;
            iniw.WriteLine(s);
        }



        iniw.Close();
        inis.Close();
        MessageBox.Show("Done");
    }

}